require_relative 'blog_api'

RSpec.describe ApiResource::Resource do

  class MyResource < ApiResource::Resource; end

  let(:resource_class) { MyResource }

  let(:resource_name) { MyResource.to_s.tableize }

  it 'return tabeleized class name' do
    expect(resource_class.resource_path).to eq(resource_name)
  end

  context '::by_resource' do
    it 'prepends parent resource path' do
      expect(resource_class.by_foo_bar('44').resource_path).to eq("foo_bars/44/#{ resource_name }")
    end

    it 'prepends multiple parent resource paths' do
      expect(resource_class.by_bar(15).by_foo(88).resource_path).to eq("foos/88/bars/15/#{ resource_name }")
    end
  end

  context '#by_resource' do
    it 'prepends parent resource path' do
      expect(resource_class.new.by_foo_bar('44').resource_path).to eq("foo_bars/44/#{ resource_name }")
    end

    it 'prepends multiple parent resource paths' do
      expect(resource_class.new.by_bar(15).by_foo(88).resource_path).to eq("foos/88/bars/15/#{ resource_name }")
    end
  end
end